[[post_data {
    "author" : "KyMAN",
    "since" : 20230520,
    "version" : 20230520
}]]
# LibreTranslate

El proyecto LibreTranslate es un proyecto libre y abierto el cual puede ser usado de forma local o de forma remota, ya sea desde un servidor externo o un servidor que se pueda montar uno mismo. Las Webs oficiales del proyecto son las siguientes:

- https://libretranslate.com/
- https://libretranslate.org/
- https://github.com/LibreTranslate/LibreTranslate

## Descripción

Básicamente, es un traductor como la Web de Google Translate, aunque éste sea peor a nivel de resultados así como de datos aportados en la traducción, incluyendo API, el cual es muy sencillo. Se basa en modelos de traducción de idioma origen a idioma destino, y suele basarse en puentes de traducción entre idiomas haciendo como idioma principal el Inglés, el cual es usado para traducir cara los distintos idiomas. Si por ejemplo, uno quisiese traducir del Español al Japonés un texto, éste lo traduciría primero al Inglés y luego al Japonés. En total, posee 31 idiomas de trabajo a fecha de este escrito, el cual consta de 60 modelos de traducción.

Actualmente posee dos formas de traducir, las cuales son a partir de un texto directo; o traducción directa de HTML en versión BETA con errores.

> [[! note NOTA]]: El consumo de recursos es bastante pequeño, contando sobretodo con que fue instalado en una Máquina Virtual Debian 11.7 amd64 Core mononúcleo sobre VirtualBox y éste responde relativamente rápido a las peticiones.

## Instalación

Para la instalación tenemos dos opciones: una instalado a partir de PIP de forma directa; y la otra es hacer una instalación manual de la versión actual del Git, aunque también requerirá de PIP para la instalación local.

> [[! note NOTA]]: La instalación directa vía PIP permite usar el LibreTranslate como librería dentro de los proyectos Python que queramos, sin embargo, en este proyecto está orientado a ser consumido como un API.

> [[! important IMPORTANTE]]: También se puede instalar desde Docker entre otras opciones, pero no las contemplamos para los fines utilizados en este proyecto.

### Instalación vía PIP

Para instalar el LibreTranslate vía PIP lo primero es tener instalado PIP

```sh
#!/bash/bin
sudo apt update
sudo apt install python3 python3-pip
```

Una vez tengamos PIP instalado, simplemente hemos de instalar LibreTranslate desde los repositorios tal que así:

```sh
#!/bin/bash
pip install libretranslate
```

> [[! note NOTA]]: Continuamos con la instalación pese a que la instalación oficial acaba aquí pues de forma directa no funciona como determina la documentación oficial.

Para poder ejecutar el LibreTranslate, hemos de ir al siguiente Path:

```sh
#!/bin/bash
cd ~/.local/lib/python3.9/site-packages/libretranslate
```

> [[! note NOTA]]: Cambiaríamos la versión de Python en el Path según tengamos en ese momento, por ejemplo, como versión actual sería "python3.10".

Una vez allí, simplemente hemos de ejecutar el archivo "main.py" del proyecto.

```sh
#!/bin/bash
python3 main.py --host 192.168.0.100 --port 5000
```

> [[! note NOTA]]: Se especifica la IP para que éste pueda escuchar a nivel de red, sino sólo escuchará peticiones Loopback al 127.0.0.1.

### Instalación vía Git

Para empezar, hemos de tener instalado tanto PIP como Git, lo cual podemos hacer de la siguiente manera:

```sh
#!/bin/bash
sudo apt update
sudo apt install python3 python3-pip git
```

Para continuar, hemos de clonar el proyecto en el directorio donde queramos instalar el LibreTranslate.

```sh
#!/bin/bash
git clone https://github.com/LibreTranslate/LibreTranslate
```

Una vez descargamos el repositorio, hemos de entrar dentro de éste e instalarlo.

```sh
#!/bin/bash
cd LibreTranslate
pip install -e .
```

Finalmente, para ejecutarlo, simplemente hemos de hacer los siguiente desde dentro del mismo repositorio:

```sh
#!/bin/bash
libretranslate --host 192.168.0.100 --port 5000
```

> [[! note NOTA]]: También admite la ejecución desde el propio "main.py" del repositorio.

> [[! note NOTA]]: Se especifica la IP para que éste pueda escuchar a nivel de red, sino sólo escuchará peticiones Loopback al 127.0.0.1.

[[html_data {
    "title" : "LibreTranslate - LibreTranslatePlus",
    "url" : "https://libretranslateplus.k3y.pw/doc/es/LibreTranslate.html",
    "author" : "KyMAN",
    "since" : 20230520,
    "version" : 20230520,
    "key_words" : "kyman,libretranslateplus,ltp,libretranslate,python,py,traductor",
    "description" : "LibreTranslate.",
    "project" : "LibreTranslatePlus",
    "logo" : "https://libretranslateplus.k3y.pw/images/LibreTranslatePlus.png",
    "language" : "es"
}]]